<template lang="pug">
  section.hero(@mousemove="backgroundTransition" :style="{ background: newTransitions }")
    .wrapper
      .hero__logo
        .logo__icon(v-html="$icons['landing-logo']")
        span.logo__title Photo<br>Creator
      h1.hero__title#title
        | <span class="hero__title--outline">Don't search for stock photos.</span> Create them
      .hero__description
        a.description__button(href="/creator/dashboard")
          span.button__label Start creating
          .button__icon(v-html="$icons.buttonArrow")
        div.description__video(v-on:click="showVideo = true") Play video&nbsp;
          span.video__time (0:54)
          .video__button
            .button__triangle
      .hero__screenshot
        .screenshot__window(v-html="$icons.window")
        .screenshot__item#screenshot
          img(src="../../static/vue-static/screenshot.png")

    popup-window(
      v-bind:shown="showVideo"
      v-on:close="showVideo = false"
    )
      div(slot="content")
        iframe(
          width="100%"
          height="450"
          v-bind:src="`https://www.youtube.com/embed/WC71Rdg_Hng?autoplay=1`"
          allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen=""
        )
</template>

<script>
import { TweenLite, TimelineLite } from "gsap";
import Rellax from "rellax";

export default {
  data() {
    const colours = [["#B4CDC5", "#92BEB0"], ["#E79CA6", "#D5848F"]];
    const transitions = [];

    return {
      showVideo: false,
      colours,
      transitions
    };
  },
  computed: {
    isMobile: function() {
      return (
        typeof window.orientation !== "undefined" ||
        navigator.userAgent.indexOf("IEMobile") !== -1
      );
    },
    newTransitions: function() {
      return `linear-gradient(${this.transitions[0]}, ${this.transitions[1]})`;
    }
  },
  mounted: function() {
    this.animateTitle();
    if (!this.isMobile) {
      this.parallax();
    }
  },
  methods: {
    parallax: function() {
      const rellax = new Rellax("#screenshot", {
        speed: 1
      });
    },
    transitionColor: function(from, to, width, x, y) {
      const { rgb2hex } = this;

      const m = (x + y) / 1.5 / width;

      const r = Math.ceil(from[0] * m + to[0] * (1 - m));

      const g = Math.ceil(from[1] * m + to[1] * (1 - m));

      const b = Math.ceil(from[2] * m + to[2] * (1 - m));

      return rgb2hex("rgb(" + r + ", " + g + ", " + b + ")");
    },

    hex2rgb: function(hex) {
      var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
      return (
        "rgb(" +
        parseInt(result[1], 16) +
        "," +
        parseInt(result[2], 16) +
        "," +
        parseInt(result[3], 16) +
        ")"
      );
    },

    rgb2hex: function(rgb) {
      rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);

      function hex(x) {
        return ("0" + parseInt(x).toString(16)).slice(-2);
      }
      return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
    },

    rgbArray: function(rgb) {
      return rgb
        .split("(")[1]
        .split(")")[0]
        .split(",");
    },

    backgroundTransition: function(e) {
      if (!this.isMobile) {
        const { colours, transitionColor, rgbArray, hex2rgb } = this;

        const xPos = e.pageX;

        const yPos = e.pageY;

        const width = window.innerWidth;

        const topLeft = hex2rgb(colours[0][0]);

        const topRight = hex2rgb(colours[1][0]);

        const bottomLeft = hex2rgb(colours[0][1]);

        const bottomRight = hex2rgb(colours[1][1]);

        const bottomTransition = transitionColor(
          rgbArray(bottomRight),
          rgbArray(bottomLeft),
          width,
          xPos,
          yPos
        );

        const topTransition = transitionColor(
          rgbArray(topRight),
          rgbArray(topLeft),
          width,
          xPos,
          yPos
        );

        this.transitions = [topTransition, bottomTransition];
      }
    },
    animateTitle: function() {
      const timeline = new TimelineLite();

      const splitText = new SplitText("#title", { type: "words,chars" });

      const chars = splitText.chars;

      TweenLite.set("#title", { visibility: "visible", perspective: 400 });

      timeline.staggerFromTo(
        chars,
        0.8,
        {
          opacity: 0,
          scale: 0,
          y: 80,
          rotationX: 180,
          transformOrigin: "0% 50% -50",
          ease: Back.easeOut
        },
        {
          opacity: 1,
          scale: 1,
          y: 0,
          rotationX: 0,
          transformOrigin: "0% 50% -50",
          ease: Back.easeOut
        },
        0.01,
        "+=0"
      );
    }
  }
};
</script>

<style lang="scss" scoped>
.hero {
  width: 100%;
  height: 100%;
  background-color: #b4cdc5;
  color: #fff;

  @media (min-width: 1024px) {
    min-height: 100vh;
  }

  &__logo {
    display: flex;
    align-items: center;
    margin-top: 64px;

    .logo {
      &__icon {
        width: 42px;
        height: 42px;
      }

      &__title {
        font-weight: 600;
        font-size: 20px;
        line-height: 22px;
        text-transform: uppercase;
        margin-left: 16px;
      }
    }
  }

  &__circle {
    width: 48px;
    height: 48px;
    background: #fff;
    border-radius: 100%;
    cursor: pointer;
    transition: 0.2s;
    will-change: transform;

    @media (min-width: 576px) {
      margin-top: 56px;
    }

    &:before {
      display: block;
      position: relative;
      content: "";
      width: 48px;
      height: 48px;
      background: #fff;
      border-radius: 100%;
      opacity: 0.5;
      z-index: -1;
      transition: 0.4s;
      will-change: transform;
    }

    &:hover {
      transform: scale(0.7);

      &:before {
        transform: scale(1.5);
      }
    }

    &:active {
      transform: scale(1);
      opacity: 0.7;

      &:before {
        transform: scale(1);
      }
    }
  }

  &__title {
    position: relative;
    text-transform: uppercase;
    font-style: normal;
    font-weight: 700;
    line-height: 38px;
    font-size: 36px;
    letter-spacing: -2px;
    margin-top: 32px;
    visibility: hidden;

    @media (min-width: 576px) {
      line-height: 71px;
      font-size: 70px;
      letter-spacing: -4px;
    }

    &--outline {
      color: rgba(255, 255, 255, 0);
      -webkit-text-stroke-width: 1.5px;
      -webkit-text-stroke-color: #fff;

      @media (min-width: 576px) {
        -webkit-text-stroke-width: 2px;
      }
    }
  }

  &__description {
    display: flex;
    flex-direction: column;
    align-items: center;

    @media (min-width: 576px) {
      flex-direction: row;
    }

    & .description {
      &__button {
        position: relative;
        display: flex;
        justify-content: center;
        box-sizing: border-box;
        width: 100%;
        margin-bottom: 16px;
        padding: 16px 36px;
        background: #fff;
        font-size: 15px;
        font-weight: 500;
        color: #1a1a1a;
        border-radius: 32px;
        text-decoration: none;
        transition: 0.2s;
        opacity: 0;
        animation: descriptionAnimation 0.4s ease-out 0.7s forwards;

        &:hover {
          background: #28b351;
          color: #fff;

          .button__icon {
            fill: #fff;
          }
        }

        @media (min-width: 576px) {
          align-items: center;
          width: auto;
          margin-right: 24px;
          margin-bottom: 0;
        }

        & .button {
          &__icon {
            display: inline-block;
            position: relative;
            top: 2px;
            width: 14px;
            height: 20px;
            margin-left: 8px;
            fill: #1a1a1a;
          }
        }
      }

      &__video {
        display: flex;
        align-items: center;
        font-weight: 400;
        opacity: 0;
        cursor: pointer;
        animation: descriptionAnimation 0.4s ease-out 0.75s forwards;
        transition: 0.4s cubic-bezier(0.86, 0, 0.07, 1);

        &:hover {
          .video__button {
            transform: scale(0.9);
          }

          .video__button:before {
            transform: scale(2);
            opacity: 0;
          }

          .video__button:after {
            transform: scale(1.1);
            opacity: 1;
          }

          .video__button .button__triangle:after {
            transform: scale(1.15);
            opacity: 1;
          }
        }

        .video {
          &__time {
            opacity: 0.7;
          }

          &__button {
            display: flex;
            justify-content: center;
            align-items: center;
            width: 40px;
            height: 40px;
            margin-left: 16px;
            border-radius: 100%;
            border: 1px solid rgba(#fff, 0.4);
            transition: 0.1s cubic-bezier(0.86, 0, 0.07, 1);

            &:before {
              display: block;
              position: absolute;
              content: "";
              width: 40px;
              height: 40px;
              border-radius: 100%;
              background: #fff;
              transform: scale(0);
              opacity: 1;
              transition: 0.4s cubic-bezier(0.86, 0, 0.07, 1);
            }

            &:after {
              display: block;
              position: absolute;
              content: "";
              width: 40px;
              height: 40px;
              border-radius: 100%;
              background: #fff;
              transform: scale(0);
              opacity: 0;
              transition: 0.3s cubic-bezier(0.86, 0, 0.07, 1);
            }

            .button {
              &__triangle {
                position: relative;
                left: 1px;
                width: 0;
                height: 0;
                border-style: solid;
                border-width: 4px 0 4px 8px;
                border-color: transparent transparent transparent #ffffff;
                z-index: 1;

                &:after {
                  display: block;
                  position: absolute;
                  top: -4px;
                  left: -8px;
                  content: "";
                  width: 0;
                  height: 0;
                  border-style: solid;
                  border-width: 4px 0 4px 8px;
                  border-color: transparent transparent transparent #1a1a1a;
                  transform: scale(2);
                  opacity: 0;
                  transition: 0.2s cubic-bezier(0.86, 0, 0.07, 1);
                  z-index: 1;
                }
              }
            }
          }
        }
      }
    }
  }

  &__screenshot {
    background: #1a1a1a;
    width: 90%;
    height: 90%;
    left: 0;
    right: 0;
    margin: 32px auto 0;
    border-radius: 6px 6px 0 0;
    overflow: hidden;
    opacity: 0;
    animation: screenshotAnimation 0.4s ease-out 0.75s forwards;

    @media (min-width: 1440px) {
      width: 100%;
      height: 58vh;
      left: auto;
      right: auto;
      margin: 70px auto 0;
    }

    & .screenshot {
      &__window {
        position: relative;
        width: 100%;
        z-index: 2;
        height: 20px;

        @media (min-width: 576px) {
          height: 26px;
        }
      }

      &__item {
        position: relative;
        top: -8px;
        z-index: 1;

        & img {
          width: 100%;
        }
      }
    }
  }

  @keyframes descriptionAnimation {
    0% {
      opacity: 0;
      transform: rotateX(90deg) translateY(80px);
      transform-origin: 0% 50% -50;
    }
    100% {
      opacity: 1;
      transform: rotateX(0deg) translateY(0);
    }
  }

  @keyframes screenshotAnimation {
    0% {
      opacity: 0;
      transform: translateY(40px);
    }
    100% {
      opacity: 1;
      transform: translateY(0);
    }
  }
}

.wrapper {
  position: relative;
  margin: 0 auto;
  padding: 32px 0 0;
  max-width: 1040px;

  @media (max-width: 1024px) {
    padding: 32px 16px 0;
  }
}

.popup-window {
  iframe {
    border: none;
  }

  /deep/ .wrapper {
    width: 800px;
    max-width: 1024px !important;

    .block {
      padding-top: 64px !important;
    }
  }
}
</style>
